function report_bonus(reporting) {
  "use strict";
  var model = openerp;

  reporting.ReportBonusWidget = reporting.Base.extend({
    template: 'ReportBonus',
    content: [],
    rowsData: [],
    modules: ['hr'],
    events: {
      'click #toolbar > button': 'clickOnAction',
      'click #generate': 'fetchGenerate',
      'click-row.bs.table #table ': 'clickAnalysisDetail',
      'change #current-date': 'ShowDateRange',
      'change #current-store': 'updateEmployee',
      'change #current-company': 'updateStore',
      'change #current-period': 'updatePeriodSelections',
    },

    init: function(parent) {
      this._super(parent);
    },

    start: function() {
      var table = this.$el.find('#table');
      table.bootstrapTable({
        data: self.rowsData
      });
      var date = new model.eiru_reports.ReportDatePickerWidget(self);
      date.fecthFecha();
      this.fetchInitial();
    },

    checkModel: function(model) {
      var self = this;
      return _.filter(self.modules, function(item) {
        return item.name === model
      });
    },

    valorNull: function(dato) {
      var valor = "";
      if (dato) {
        valor = dato;
      }
      return valor;
    },

    ShowDateRange: function() {
      var self = this;
      var date = self.$el.find('#current-date').val();
      if (date == 'range') {
        self.$el.find('.datepicker').css('display', 'block');
      }
      if (date != 'range') {
        self.$el.find('.datepicker').css('display', 'none');
      }
    },

    clickAnalysisDetail: function(e, row, $element, field) {
      if (field == 'employee_name') {
        this.do_action({
          name: "Registro de Funcionario",
          type: 'ir.actions.act_window',
          res_model: "hr.employee",
          views: [
            [false, 'form']
          ],
          target: 'new',
          domain: [
            ['id', '=', row.employee_id]
          ],
          context: {},
          flags: {
            'form': {
              'action_buttons': false,
              'options': {
                'mode': 'view'
              }
            }
          },
          res_id: row.employee_id,
        });
      }

      if (field == 'payslip') {
        this.do_action({
          name: "Nómina",
          type: 'ir.actions.act_window',
          res_model: "hr.payslip",
          views: [
            [false, 'form']
          ],
          target: 'new',
          domain: [
            ['id', '=', row.id]
          ],
          context: {},
          flags: {
            'form': {
              'action_buttons': false,
              'options': {
                'mode': 'view'
              }
            }
          },
          res_id: row.id,
        });
      }
      e.stopImmediatePropagation();
    },

    fetchInitial: function() {
      var self = this;
      self.fecthIrModuleModule().then(function(IrModuleModule) {
        return IrModuleModule;
      }).then(function(IrModuleModule) {
        self.IrModuleModule = IrModuleModule;
        return self.fetchResCompany();
      }).then(function(ResCompany) {
        self.ResCompany = ResCompany;
        if (ResCompany.length > 1) {
          self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
          _.each(ResCompany, function(item) {
            self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.company').css('display', 'none');
        }
        return self.fetchResStore();
      }).then(function(ResStore) {
        self.ResStore = ResStore;
        if (ResStore.length > 1) {
          self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
          _.each(ResStore, function(item) {
            self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.store').css('display', 'none');
        }
        return self.fetchHrEmployee();
      }).then(function(HrEmployee) {
        self.HrEmployee = HrEmployee;
        if (HrEmployee.length > 1) {
          self.$el.find('#current-employee').append('<option value="9999999">Todos los funcionarios</option>');
          _.each(HrEmployee, function(item) {
            self.$el.find('#current-employee').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.employee').css('display', 'none');
        }
        return self.fetchAccountPeriod();
      }).then(function(AccountPeriod) {
        self.AccountPeriod = AccountPeriod;
        if (AccountPeriod.length > 1) {
          self.$el.find('#current-period').append('<option value="9999999">Todos los períodos</option>');
          _.each(AccountPeriod, function(item) {
            self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.period').css('display', 'none');
        }
        return self.fetchResCurrency();
      }).then(function(ResCurrency) {
        self.ResCurrency = ResCurrency;
      });
      self.$el.find('#generate').css('display', 'inline');
      return;
    },

    fetchGenerate: function() {
      var self = this;
      self.$el.find('.search-form').block({
        message: null,
        overlayCSS: {
          backgroundColor: '#FAFAFA'
        }
      });
      self.$el.find('.report-form').block({
        message: null,
        overlayCSS: {
          backgroundColor: '#FAFAFA'
        }
      });

      this.fetchHrPayslipInput().then(function(HrPayslipInput) {
        return HrPayslipInput;
      }).then(function(HrPayslipInput) {
        self.HrPayslipInput = HrPayslipInput;
        return self.fetchHrPayslip();
      }).then(function(HrPayslip) {
        self.HrPayslip = HrPayslip;
        return self.BuildTable();
      });
    },

    fecthIrModuleModule: function() {
      var self = this;
      var defer = $.Deferred();
      var fields = ['name', 'id'];
      var domain = [
        ['state', '=', 'installed'],
        ['name', 'in', self.modules]
      ];
      var IrModuleModule = new model.web.Model('ir.module.module');
      IrModuleModule.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      })
      return defer;
    },

    fetchResCompany: function() {
      var self = this;
      var defer = $.Deferred();
      var company = new model.web.Model('res.company');
      var field = ['id', 'name', 'currency_id', 'logo'];
      company.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    getResCompany: function(id) {
      var self = this;
      return _.filter(self.ResCompany, function(item) {
        return item.id == id;
      })
    },

    fetchResStore: function() {
      var self = this;
      var defer = $.Deferred();
      var store = new model.web.Model('res.store');
      var field = ['id', 'name', 'company_id'];
      store.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchResCurrency: function() {
      var self = this;
      var defer = $.Deferred();
      var fields = ['id', 'name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
      var domain = [
        ['active', '=', true]
      ];
      var ResCurrency = new model.web.Model('res.currency');
      ResCurrency.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    getResCurrency: function(id) {
      var self = this;
      return _.filter(self.ResCurrency, function(item) {
        return item.id === id;
      })
    },

    fetchHrEmployee: function() {
      var self = this;
      var defer = $.Deferred();
      var employee = new model.web.Model('hr.employee');
      var field = ['id', 'name', 'store_id'];
      employee.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchAccountPeriod: function() {
      var self = this;
      var defer = $.Deferred();
      var period = new model.web.Model('account.period');
      var field = ['id', 'name','date_stop'];
      period.query(field).filter().all().then(function(results) {
        results.sort(function (a, b) {
          if (a.date_stop > b.date_stop) {
            return -1;
          }
          if (a.date_stop < b.date_stop) {
            return 1;
          }
          return 0;
        });
        defer.resolve(results);
      });

      return defer;
    },

    fetchHrPayslip: function() {
      var self = this;
      var defer = $.Deferred();
      var company = self.$el.find('#current-company').val();
      var store = self.$el.find('#current-store').val();
      var employee_id = self.$el.find('#current-employee').val();
      var period = self.$el.find('#current-period').val();

      var payslip_ids = _.flatten(_.map(self.HrPayslipInput, function(item) {
        return item.id;
      }));

      var domain = [
        ['input_line_ids', 'in', payslip_ids]
      ];

      if (company && company != 9999999) {
        domain.push(['company_id', '=', parseInt(company)]);
      }

      if (store && store != 9999999) {
        domain.push(['employee_id.store_id', '=', parseInt(store)]);
      }

      if (employee_id && employee_id != 9999999) {
        domain.push(['employee_id', '=', parseInt(employee_id)]);
      }

      if (period && period != 9999999) {
        domain.push(['period_id', '=', parseInt(period)]);
      }

      var fields = [
        'id',
        'company_id',
        'employee_id',
        'input_line_ids',
      ];
      var HrPayslip = new model.web.Model('hr.payslip');
      HrPayslip.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchHrPayslipInput: function() {
      var self = this;
      var defer = $.Deferred();
      var date = self.$el.find('#current-date').val();
      var desde = self.$el.find('#from').val();
      var hasta = self.$el.find('#to').val();

      var domain = [
        ['code', '=', 'CMS']
      ]

      if (date && date != 9999999) {
        if (desde) {
          var date = desde.split('/')
          date = (date[2] + "-" + date[1] + "-" + date[0]);
          domain.push(['create_date', '>=', date]);
        }
        if (hasta) {
          var date = hasta.split('/')
          date = (date[2] + "-" + date[1] + "-" + date[0]);
          domain.push(['create_date', '<=', date]);
        }
        if (date == 'today') {
          var today = moment().format('YYYY-MM-DD ');
          domain.push(['create_date', 'like', today]);
        }
        if (date == 'yesterday') {
          var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD ');
          domain.push(['create_date', 'like', yesterday]);
        }
        if (date == 'currentMonth') {
          var currentMonth = moment().format('YYYY-MM');
          domain.push(['create_date', 'like', currentMonth]);
        }
        if (date == 'lastMonth') {
          var lastMonth = moment().add(-1, 'months').format('YYYY-MM');
          domain.push(['create_date', 'like', lastMonth]);
        }
      }

      var fields = [
        'id',
        'code',
        'name',
        'payslip_id',
        'create_date',
        'amount',
      ];

      var HrPayslip = new model.web.Model('hr.payslip.input');
      HrPayslip.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    getHrPayslip: function(id) {
      var self = this;
      return _.filter(self.HrPayslip, function(a) {
        return a.id === id;
      })
    },

    updateEmployee: function() {
      var self = this;
      var store = self.$el.find('#current-store').val();
      if (store != 9999999) {
        var employee = self.$el.find('#current-employee').empty();
        self.$el.find('#current-employee').append('<option value="9999999">Todos los funcionarios</option>');
        _.each(self.HrEmployee, function(item) {
          if (parseFloat(store) == item.store_id[0]) {
            self.$el.find('#current-employee').append('<option value="' + item.id + '">' + item.name + '</option>');
          }
        });
      } else {
        var employee = self.$el.find('#current-employee').empty();
        self.$el.find('#current-employee').append('<option value="9999999">Todos los funcionarios</option>');
        _.each(self.HrEmployee, function(item) {
          self.$el.find('#current-employee').append('<option value="' + item.id + '">' + item.name + '</option>');
        });
      }
    },

    updateStore: function() {
      var self = this;
      var company = self.$el.find('#current-company').val();
      if (company != 9999999) {
        var store = self.$el.find('#current-store').empty();
        self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
        _.each(self.ResStore, function(item) {
          if (parseFloat(company) == item.company_id[0]) {
            self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
          }
        });
      } else {
        var store = self.$el.find('#current-store').empty();
        self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
        _.each(self.ResStore, function(item) {
          self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
        });
      }
    },

    updatePeriodSelections: function() {
      var self = this;
      var period = self.$el.find('#current-period').val();
      if (period != 9999999) {
        self.$el.find('#current-date').val(9999999);
        self.$el.find('#current-date').prop('disabled', 'disabled');
        self.$el.find('.datepicker').css('display', 'none');
      } else {
        self.$el.find('#current-date').prop('disabled', false);
      }
    },

    BuildTable: function() {
      var self = this;
      var data = [];
      var company = $('#current-company').val();
      if (company && company != 9999999) {
        var ResCompany = self.getResCompany(company).shift();
        var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
      } else {
        var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
      }
      var HrPayslipInput = self.HrPayslipInput;
      _.each(HrPayslipInput, function(item) {
        var HrPayslip = self.getHrPayslip(item.payslip_id[0]);
        _.each(HrPayslip, function(index) {
          data.push({
            id: index.id,
            employee_id: index.employee_id[0],

            create_date: item.create_date,
            employee_name: index.employee_id[1],
            name: item.name,
            payslip: item.payslip_id[1],
            amount: accounting.formatMoney(item.amount, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),

            amount_no_format: item.amount,

            decimal_places: CurrencyBase.decimal_places,
            thousands_separator: CurrencyBase.thousands_separator,
            decimal_separator: CurrencyBase.decimal_separator,

          });
        })
      });

      self.content = data;
      self.loadTable(data);
      self.$el.find('.report-form').css('display', 'block');
      self.$el.find('.search-form').unblock();
      self.$el.find('.report-form').unblock();
    },

    loadTable: function(rowsTable) {
      var self = this;
      self.rowsData = rowsTable;
      var table = this.$el.find('#table');
      table.bootstrapTable('load', rowsTable);
    },

    clickOnAction: function(e) {
      var self = this;
      var action = self.$el.find(e.target).val();
      var company = $('#current-company').val();
      if (company && company != 9999999) {
        var ResCompany = self.getResCompany(company).shift();

      } else {
        var ResCompany = self.ResCompany[0];
      }
      var getColumns = [];
      var rows = [];
      var table = self.$el.find("#table");
      var column = table.bootstrapTable('getVisibleColumns');
      var row = table.bootstrapTable('getData');

      var amount = amountFormatter(row);

      row.push({
        create_date: 'Totales',
        amount: amount,

      });

      if (action === 'pdf') {
        var data = _.map(column, function(val) {
          return val.field
        });
        _.each(_.map(column, function(val) {
          return val
        }), function(item) {
          getColumns.push([{
            title: item.title,
            dataKey: item.field
          }]);
        });
        var pdf_title = 'Histórico de Comisiones';
        var pdf_type = '';
        var pdf_name = 'historico_de_comisiones_';
        var pdf_columnStyles = {
          create_date: {
            columnWidth: 20,
            halign: 'center'
          },

          employee_name: {
            columnWidth: 25,
            halign: 'left'
          },

          payslip: {
            halign: 'left'
          },

          name: {
            columnWidth: 35,
            halign: 'left'
          },

          amount: {
            columnWidth: 25,
            halign: 'center'
          },
        };

        var filter = self.getFilter();
        var pdf = new model.eiru_reports.ReportPdfWidget(self);
        pdf.drawPDF(
          _.flatten(getColumns),
          row,
          ResCompany,
          pdf_title,
          pdf_type,
          pdf_name,
          pdf_columnStyles,
          filter,
        );
      }
    },
    getFilter: function() {
      var self = this;
      var company = self.$el.find('#current-company').val();
      var store = self.$el.find('#current-store').val();
      var employee = self.$el.find('#current-employee').val();
      var period = self.$el.find('#current-period').val();
      var date = self.$el.find('#current-date').val();
      var desde = self.$el.find('#from').val();
      var hasta = self.$el.find('#to').val();

      var filter = [];

      if (company && company != 9999999) {
        var ResCompany = _.filter(self.ResCompany, function(item) {
          return item.id == company;
        });
        filter.push({
          title: 'Empresa',
          value: ResCompany[0].name,
        });
      }

      if (store && store != 9999999) {
        var ResStore = _.filter(self.ResStore, function(item) {
          return item.id == store;
        });

        filter.push({
          title: 'Sucursal',
          value: ResStore[0].name,
        });
      }

      if (employee && employee != 9999999) {
        var HrEmployee = _.filter(self.HrEmployee, function(item) {
          return item.id == employee;
        });

        filter.push({
          title: 'Funcionario',
          value: HrEmployee[0].name,
        });
      }

      if (period && period != 9999999) {
        var AccountPeriod = _.filter(self.AccountPeriod, function(item) {
          return item.id == period;
        })
        filter.push({
          title: 'Periodo',
          value: AccountPeriod[0].name,
        });
      }

      if (date && date != 9999999) {
        moment.locale('es', {
          months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
        });

        if (date == 'range') {
          filter.push({
            title: 'Fecha',
            value: desde + ' al ' + hasta,
          });

        } else {
          if (date == 'today') {
            var fecha = moment().format('DD/MM/YYYY');
          }

          if (date == 'yesterday') {
            var fecha = moment().add(-1, 'days').format('DD/MM/YYYY');
          }
          if (date == 'currentMonth') {
            var fecha = moment().format('MMMM/YYYY');
          }
          if (date == 'lastMonth') {
            var fecha = moment().add(-1, 'months').format('MMMM/YYYY');
          }

          filter.push({
            title: 'Fecha',
            value: fecha,
          });
        }
      }
      return filter;
    },
  });
}
