function report_contract_list(reporting) {
  "use strict";

  var model = openerp;

  reporting.ReportContractListWidget = reporting.Base.extend({
    template: 'ReportContractList',
    AccountVoucher: [],
    content: [],
    rowsData: [],
    modules: ['hr'],
    events: {
      'click #toolbar > button': 'clickOnAction',
      'click #generate': 'fetchGenerate',
      'click-row.bs.table #table ': 'clickAnalysisDetail',
      'change #current-company': 'updateStore',
      'chnage #current-store' : 'updateEmployee',
    },
    init: function(parent) {
      this._super(parent);
    },
    start: function() {
      var table = this.$el.find('#table');
      table.bootstrapTable({
        data: self.rowsData
      });
      var date = new model.eiru_reports.ReportDatePickerWidget(self);
      date.fecthFecha();
      this.fetchInitial();
    },

    checkModel: function(model) {
      var self = this;
      return _.filter(self.modules, function(item) {
        return item.name === model
      });
    },

    valorNull: function(dato) {
      var valor = "";
      if (dato) {
        valor = dato;
      }
      return valor;
    },

    clickAnalysisDetail: function(e, row, $element, field) {
      if (field == 'name') {
        this.do_action({
          name: "Funcionario",
          type: 'ir.actions.act_window',
          res_model: "hr.contract",
          views: [
            [false, 'form']
          ],
          target: 'new',
          domain: [
            ['id', '=', row.id]
          ],
          context: {},
          flags: {
            'form': {
              'action_buttons': false,
              'options': {
                'mode': 'view'
              }
            }
          },
          res_id: row.id,
        });
      }

      if (field == 'employee_name') {
        this.do_action({
          name: "Funcionario",
          type: 'ir.actions.act_window',
          res_model: "hr.employee",
          views: [
            [false, 'form']
          ],
          target: 'new',
          domain: [
            ['id', '=', row.employee_id]
          ],
          context: {},
          flags: {
            'form': {
              'action_buttons': false,
              'options': {
                'mode': 'view'
              }
            }
          },
          res_id: row.employee_id,
        });
      }

      e.stopImmediatePropagation();
    },

    fetchInitial: function() {
      var self = this;
      self.fecthIrModuleModule().then(function(IrModuleModule) {
        return IrModuleModule;
      }).then(function(IrModuleModule) {
        self.IrModuleModule = IrModuleModule;
        return self.fetchResCompany();
      }).then(function(ResCompany) {
        self.ResCompany = ResCompany;
        if (ResCompany.length > 1) {
          self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
          _.each(ResCompany, function(item) {
            self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.company').css('display', 'none');
        }
        return self.fetchResStore();
      }).then(function(ResStore) {
        self.ResStore = ResStore;
        if (ResStore.length > 0) {
          self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
          _.each(ResStore, function(item) {
            self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.store').css('display', 'none');
        }
        return self.fetchHrEmployee();
      }).then(function(HrEmployee) {
        self.HrEmployee = HrEmployee;
        if (HrEmployee.length > 1) {
          self.$el.find('#current-employee').append('<option value="9999999">Todos los funcionarios</option>');
          _.each(HrEmployee, function(item) {
            self.$el.find('#current-employee').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.employee').css('display', 'none');
        }
        return self.fetchHrJob();
      }).then(function(HrJob) {
        self.HrJob = HrJob;
        if (HrJob.length > 1) {
          self.$el.find('#current-job').append('<option value="9999999">Todos los cargos</option>');
          _.each(HrJob, function(item) {
            self.$el.find('#current-job').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.job').css('display', 'none');
        }
        return self.fetchHrContractType();
      }).then(function(HrContractType) {
        self.HrContractType = HrContractType;
        if (HrContractType.length > 1) {
          self.$el.find('#current-type').append('<option value="9999999">Todos los tipos</option>');
          _.each(HrContractType, function(item) {
            self.$el.find('#current-type').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.type').css('display', 'none');
        }
        return self.fetchHrPayrollStructure();
      }).then(function(HrPayrollStructure) {
        self.HrPayrollStructure = HrPayrollStructure;
        if (HrPayrollStructure.length > 1) {
          self.$el.find('#current-struct').append('<option value="9999999">Todos los tipos</option>');
          _.each(HrPayrollStructure, function(item) {
            self.$el.find('#current-struct').append('<option value="' + item.id + '">' + item.name + '</option>');
          });
        } else {
          self.$el.find('.struct').css('display', 'none');
        }
        return self.fetchResCurrency();
      }).then(function(ResCurrency) {
        self.ResCurrency = ResCurrency;
      });
      self.$el.find('#generate').css('display', 'inline');
      return;
    },

    fetchGenerate: function() {
      var self = this;
      self.$el.find('.search-form').block({
        message: null,
        overlayCSS: {
          backgroundColor: '#FAFAFA'
        }
      });
      self.$el.find('.report-form').block({
        message: null,
        overlayCSS: {
          backgroundColor: '#FAFAFA'
        }
      });

      this.fetchHrContract().then(function(HrContract) {
        return HrContract;
      }).then(function(HrContract) {
        self.HrContract = HrContract;
        return self.BuildTable();
      });
    },

    fecthIrModuleModule: function() {
      var self = this;
      var defer = $.Deferred();
      var fields = ['name', 'id'];
      var domain = [
        ['state', '=', 'installed'],
        ['name', 'in', self.modules],
      ];
      var IrModuleModule = new model.web.Model('ir.module.module');

      IrModuleModule.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    /*====================================================================
        RES COMPANY
    ====================================================================*/
    fetchResCompany: function() {
      var self = this;
      var defer = $.Deferred();
      var currency = new model.web.Model('res.company');
      var field = ['id', 'name', 'currency_id', 'logo'];
      currency.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    getResCompany: function(id) {
      var self = this;
      return _.filter(self.ResCompany, function(item) {
        return item.id == id;
      })
    },

    fetchResCurrency: function() {
      var self = this;
      var defer = $.Deferred();
      var fields = ['id', 'name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
      var domain = [
        ['active', '=', true]
      ];
      var ResCurrency = new model.web.Model('res.currency');
      ResCurrency.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    getResCurrency: function(id) {
      var self = this;
      return _.filter(self.ResCurrency, function(item) {
        return item.id === id;
      })
    },

    fetchResStore: function() {
      var self = this;
      var defer = $.Deferred();
      var store = new model.web.Model('res.store');
      var field = ['id', 'name', 'company_id'];
      store.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchHrJob: function() {
      var self = this;
      var defer = $.Deferred();
      var job = new model.web.Model('hr.job');
      var field = ['id', 'name'];
      job.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchHrContractType: function() {
      var self = this;
      var defer = $.Deferred();
      var type = new model.web.Model('hr.contract.type');
      var field = ['id', 'name'];
      type.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchHrPayrollStructure: function() {
      var self = this;
      var defer = $.Deferred();
      var struct = new model.web.Model('hr.payroll.structure');
      var field = ['id', 'name'];
      struct.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchHrEmployee: function() {
      var self = this;
      var defer = $.Deferred();
      var employee = new model.web.Model('hr.employee');
      var field = ['id', 'name'];
      employee.query(field).filter().all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    fetchHrContract: function() {
      var self = this;
      var defer = $.Deferred();
      var domain = [];
      var company = self.$el.find('#current-company').val();
      var store = self.$el.find('#current-store').val();
      var employee = self.$el.find('#current-employee').val();
      var job = self.$el.find('#current-job').val();
      var type = self.$el.find('#current-type').val();
      var struct = self.$el.find('#current-struct').val();


      if (company && company != 9999999) {
        domain.push(['employee_id.company_id', '=', parseInt(company)]);
      }

      if (store && store != 9999999) {
        domain.push(['employee_id.store_id', '=', parseInt(store)]);
      }

      if (employee && employee != 9999999) {
        domain.push(['employee_id', '=', parseInt(employee)]);
      }

      if (job && job != 9999999) {
        domain.push(['job_id', '=', parseInt(job)]);
      }

      if (type && type != 9999999) {
        domain.push(['type_id', '=', parseInt(type)]);
      }

      if (struct && struct != 9999999) {
        domain.push(['struct_id', '=', parseInt(struct)]);
      }

      var fields = [
        'id',
        'name',
        'employee_id',
        'name',
        'job_id',
        'type_id',
        'wage',
        'struct_id',
        'date_start',
        'date_end',

      ];

      var HrEmployee = new model.web.Model('hr.contract');
      HrEmployee.query(fields).filter(domain).all().then(function(results) {
        defer.resolve(results);
      });
      return defer;
    },

    updateEmployee: function() {
      var self = this;
      var store = self.$el.find('#current-store').val();
      if (store != 9999999) {
        var employee = self.$el.find('#current-employee').empty();
        self.$el.find('#current-employee').append('<option value="9999999">Todos los funcionarios</option>');
        _.each(self.HrEmployee, function(item) {
          if (parseFloat(store) == item.store_id[0]) {
            self.$el.find('#current-employee').append('<option value="' + item.id + '">' + item.name + '</option>');
          }
        });
      } else {
        var employee = self.$el.find('#current-employee').empty();
        self.$el.find('#current-employee').append('<option value="9999999">Todos los funcionarios</option>');
        _.each(self.HrEmployee, function(item) {
          self.$el.find('#current-employee').append('<option value="' + item.id + '">' + item.name + '</option>');
        });
      }
    },

    updateStore: function() {
      var self = this;
      var company = self.$el.find('#current-company').val();
      if (company != 9999999) {
        var store = self.$el.find('#current-store').empty();
        self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
        _.each(self.ResStore, function(item) {
          if (parseFloat(company) == item.company_id[0]) {
            self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
          }
        });
      } else {
        var store = self.$el.find('#current-store').empty();
        self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
        _.each(self.ResStore, function(item) {
          self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
        });
      }
    },

    /*====================================================================
        BUILD
    ====================================================================*/
    BuildTable: function() {
      var self = this;
      var data = [];
      var company = $('#current-company').val();
      if (company && company != 9999999) {
        var ResCompany = self.getResCompany(company).shift();
        var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
      } else {
        var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
      }

      var HrContract = self.HrContract;
      _.each(HrContract, function(item) {
        if (item.date_end) {
          var date_end = moment(item.date_end, 'YYYY-MM-DD').format('DD-MM-YYYY');
        } else {
          var date_end = 'En curso';
        }

        data.push({
          id: item.id,
          employee_id: self.valorNull(item.employee_id[0]),

          name: self.valorNull(item.name),
          employee_name: self.valorNull(item.employee_id[1]),
          job_id: self.valorNull(item.job_id[1]),
          type_id: self.valorNull(item.type_id[1]),
          wage: accounting.formatMoney(item.wage, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
          struct_id: self.valorNull(item.struct_id[1]),
          date_start: moment(item.date_start, 'YYYY-MM-DD').format('DD-MM-YYYY'),
          date_end: date_end,

          wage_no_format: item.wage,

          decimal_places: CurrencyBase.decimal_places,
          thousands_separator: CurrencyBase.thousands_separator,
          decimal_separator: CurrencyBase.decimal_separator,
        });
      });
      self.content = data;
      self.loadTable(data);
      self.$el.find('.report-form').css('display', 'block');
      self.$el.find('.search-form').unblock();
      self.$el.find('.report-form').unblock();
    },

    loadTable: function(rowsTable) {
      var self = this;
      self.rowsData = rowsTable;
      var table = this.$el.find('#table');
      table.bootstrapTable('load', rowsTable);
    },

    clickOnAction: function(e) {
      var self = this;
      var ResCompany;
      var action = this.$el.find(e.target).val();
      var company = $('#current-company').val();
      if (company && company != 9999999) {
        var ResCompany = self.getResCompany(company).shift();
      } else {
        var ResCompany = self.ResCompany[0];
      }
      var getColumns = [];
      var rows = [];
      var table = this.$el.find("#table");
      var column = table.bootstrapTable('getVisibleColumns');
      var row = table.bootstrapTable('getData');

      var wage = wageFormatter(row);

      row.push({
        name:'Totales',
        wage: wage,
      });
      if (action === 'pdf') {
        var data = _.map(column, function(val) {
          return val.field
        });
        _.each(_.map(column, function(val) {
          return val
        }), function(item) {
          getColumns.push([{
            title: item.title,
            dataKey: item.field
          }]);
        });
        var pdf_title = 'Lista de Contratos';
        var pdf_type = '';
        var pdf_name = 'lista_de_contratos_';
        var pdf_columnStyles = {
          name: {
            halign: 'left'
          },
          employee_name: {
            columnWidth: 25,
            halign: 'left'
          },
          job_id: {
            columnWidth: 20,
            halign: 'center'
          },
          type_id: {
            columnWidth: 20,
            halign: 'left'
          },
          wage: {
            columnWidth: 20,
            halign: 'center'
          },
          struct_id: {
            columnWidth: 19,
            halign: 'center'
          },
          date_start: {
            columnWidth: 16,
            halign: 'center'
          },
          date_end: {
            columnWidth: 22,
            halign: 'center'
          },
        };
        var filter = self.getFilter();
        var pdf = new model.eiru_reports.ReportPdfWidget(self);
        pdf.drawPDF(
          _.flatten(getColumns),
          row,
          ResCompany,
          pdf_title,
          pdf_type,
          pdf_name,
          pdf_columnStyles,
          filter,
        );
      }
    },

    getFilter: function() {
      var self = this;
      var company = self.$el.find('#current-company').val();
      var store = self.$el.find('#current-store').val();
      var employee = self.$el.find('#current-employee').val();
      var job = self.$el.find('#current-job').val();
      var type = self.$el.find('#current-type').val();
      var struct = self.$el.find('#current-struct').val();

      var filter = [];

      if (company && company != 9999999) {
        var ResCompany = _.filter(self.ResCompany, function(item) {
          return item.id == company;
        });
        filter.push({
          title: 'Empresa',
          value: ResCompany[0].name,
        });
      }

      if (store && store != 9999999) {
        var ResStore = _.filter(self.ResStore, function(item) {
          return item.id == store;
        });

        filter.push({
          title: 'Sucursal',
          value: ResStore[0].name,
        });
      }

      if (employee && employee != 9999999) {
        var HrEmployee = _.filter(self.HrEmployee, function(item) {
          return item.id == employee;
        });

        filter.push({
          title: 'Funcionario',
          value: HrEmployee[0].name,
        });
      }

      if (job && job != 9999999) {
        var HrJob = _.filter(self.HrJob, function(item) {
          return item.id == job;
        });

        filter.push({
          title: 'Cargo',
          value: HrJob[0].name,
        });
      }

      if (type && type != 9999999) {
        var HrContractType = _.filter(self.HrContractType, function(item) {
          return item.id == type;
        });

        filter.push({
          title: 'Tipo de Contrato',
          value: HrContractType[0].name,
        });
      }

      if (struct && struct != 9999999) {
        var HrPayrollStructure = _.filter(self.HrPayrollStructure, function(item) {
          return item.id == struct;
        });

        filter.push({
          title: 'Estructura Salarial',
          value: HrPayrollStructure[0].name,
        });
      }
      return filter;
    },
  });
}
